<?php
//ini_set("display_errors",1);
//error_reporting(E_ALL);
/**
 * @version		1.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @subpackage	EgoPay 
 * @author  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu 
 * @copyright	Copyright  2013 - All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 */

class os_egopay extends os_payment {
	/**
	 * Payment url
	 *
	 * @var string
	 */
	var $_url = null ;
	/**
	 * Array of params will be posted to server
	 *
	 * @var string
	 */
	var $_params = array();
	/**
	 * Array containing data posted from 2checkout to our server
	 *
	 * @var array
	 */
	var $_data = array();
	/**
	 * Constructor functions, init some parameter
	 *
	 * @param object $params
	 */
	function os_egopay($params) {
		parent::setName('os_egopay');
		parent::os_payment();						
		parent::setCreditCard(false);		
    	parent::setCardType(false);
    	parent::setCardCvv(false);
    	parent::setCardHolderName(false);
		$this->ipn_log = true ;
		$this->ipn_log_file = JPATH_COMPONENT.DS.'egopay_logs.txt';
    
		$this->_url = EgoPaySci::EGOPAY_PAYMENT_URL;
		$this->setParam('egopay_user', $params->get('egopay_user'));
    $this->setParam('egopay_password', $params->get('egopay_password'));
    $this->setParam('egopay_currency', $params->get('egopay_currency'));	
	}
	/**
	 * Set param value
	 *
	 * @param string $name
	 * @param string $val
	 */
	function setParam($name, $val) {
		$this->_params[$name] = $val;
	}
	/**
	 * Setup payment parameter
	 *
	 * @param array $params
	 */
	function setParams($params) {
		foreach ($params as $key => $value) {
			$this->_params[$key] = $value ;
		}
	}
	/**
	 * Payment processing
	 *
	 * @param object $row
	 * @param array $data
	 */
	function processPayment($row, $data) {
    $siteUrl = JURI::base() ;					
		$Itemid = JRequest::getInt('Itemid') ;
		//Billing address
    $hash="";
    if($this->_params['egopay_user']!="" && $this->_params['egopay_password']!="")
    {
      $oEgopay = new EgoPaySci(array(
        'store_id' => $this->_params['egopay_user'],
        'store_password' => $this->_params['egopay_password']
      ));
      
      $hash_arr=array(
        'amount' => number_format(round($data['amount'], 2),2),
        'currency' => $this->_params['egopay_currency'],
        'description' => $data['item_name'],
        'cf_1' => $row->id,
      );
      $hash_arr['success_url']=$siteUrl.'index.php?option=com_pmform&view=complete&id='.$row->id.'&Itemid='.$Itemid;
      $hash_arr['fail_url']=$siteUrl.'index.php?option=com_pmform&view=cancel&id='.$row->id.'&Itemid='.$Itemid;
      $hash_arr['callback_url']=$siteUrl.'index.php?option=com_pmform&task=payment_confirm&payment_method=os_egopay&id='.$row->id;
      $hash = $oEgopay->createHash($hash_arr);
    }
    
    
		$this->setParam('hash', $hash);
		$this->submitPost();		
	}
	/**
	 * Submit post to EgoPay server
	 *
	 */	
	function submitPost() {
    if(trim($this->_params['egopay_user'])=='')
    {
      ?>
      <font color="red"><strong>Please input your EgoPay Store ID</strong></font>
      <?php
    }
    else if(trim($this->_params['egopay_password'])=='')
    {
      ?>
      <font color="red"><strong>Please input your EgoPay Store Password</strong></font>
      <?php
    }
    else
    {
		?>			
		<div class="contentheading"><?php echo  JText::_('OS_WAIT_EGOPAY'); ?></div>							
		<form method="post" action="<?php echo $this->_url; ?>" name="os_form" id="os_form">
			<?php
				echo '<input type="hidden" name="hash" value="'.$this->_params['hash'].'" />';
			?>
			<script type="text/javascript">
				function redirect() {
					document.os_form.submit();
				}
				setTimeout('redirect()',3000);
			</script>
		</form>
	<?php
    }
	}
	/**
	 * Validate the post data from EgoPay to our server
	 *
	 * @return string
	 */
	function _validate() {		  
	    foreach ($_REQUEST as $key=>$value) { 
	       $this->_data[$key] = $value;	     
	    }
	    $id = JRequest::getInt('id', 0) ;    		    		    	      	   
	    $this->log_ipn_results(true); 	   
	    if (!$id)
	    	return false ;
	    
      $order_paid=0;
      
      $egopay_store_id = $this->_params['egopay_user'];
      $egopay_store_password = $this->_params['egopay_password'];
      
      $EgoPay = new EgoPaySciCallback(array(
                  'store_id' => $egopay_store_id,
                  'store_password' => $egopay_store_password
              ));
      $egopay_data = $EgoPay->getResponse($_POST);
      switch ($egopay_data['sStatus']) {
          case 'Completed':
              $order_paid=1;
              break;
          case 'TEST SUCCESS':
              $order_paid=1;
              break;
          case 'Pending':
          case 'On Hold':
              $order_paid=2;
              break;
          case 'Canceled':
              $order_paid=0;
              break;
          default:
              $order_paid=0;
              break;
      }
      if($order_paid==0)
      {
        return false;
      }
      if($order_paid==1)
      {
        return true;
      }
      exit;
	}
	/**
	 * Log IPN result
	 *
	 * @param string $success
	 */
	function log_ipn_results($success) {
      if (!$this->ipn_log) return;
      $text = '['.date('m/d/Y g:i A').'] - '; 
      if ($success) $text .= "SUCCESS!\n";
      	else $text .= 'FAIL: '.$this->last_error."\n"; 
      $text .= "IPN POST Vars from egopay:\n";
      foreach ($this->_data as $key=>$value) {
         $text .= "$key=$value, ";
      }
      $text .= "\nIPN Response from egopay Server:\n ".$this->ipn_response;
      $fp=fopen($this->ipn_log_file,'a');
      fwrite($fp, $text . "\n\n"); 
      fclose($fp);  // close file
   }
	/**
	 * Process payment 
	 *
	 */
	function verifyPayment() {
	    $mainframe = & JFactory::getApplication() ;
	    $Itemid = JRequest::getInt('Itemid');
		$ret = $this->_validate();
    $id = $this->_data['id'];	
		if ($ret) {
			$config = PmFormHelper::getConfig() ;
			$row = & JTable::getInstance('pmform', 'Payment');
   			$row->load($id);				
   			$transactionId = @$this->_data['sId'];
   			$row->transaction_id = $transactionId ;
   			$row->payment_date =  date('Y-m-d H:i:s');
   			$row->published = 1;
   			$row->store();						
			PmFormHelper::sendEmails($row, $config);	   			
			JPluginHelper::importPlugin( 'pmform' );
			$dispatcher =& JDispatcher::getInstance();
			$dispatcher->trigger( 'onAfterPaymentSuccess', array($row));
   			return true;	
		} else {
			$mainframe->redirect('index.php?option=com_pmform&view=failure&id='.$id.'&Itemid='.$Itemid);
			return false;
		}		     
	}		
}
/**
 * EgoPay Sci Class
 * @author EgoPay
 * @copyright 2013   
 */
class EgoPaySci
{
    /**
     * EgoPay SCI url
     */
    const EGOPAY_PAYMENT_URL = "https://www.egopay.com/payments/pay";
    
    /**
     * EgoPay Store ID
     */
    protected $_storeId;
    
    /**
     * EgoPay Store password
     */
    protected $_storePassword;
    
    /**
     * Set these urls if you don't want use the ones you have in the website
     * User gets redirected after success payment
     */
    protected $_successUrl;
    
    /**
     * User gets redirected then he goes back without paying
     */
    protected $_failUrl;
    
    /**
    * Constructor
    * @param mixed $aParams - parameters that initiate API object
    * The available parameters are:
    * Required:
    *   store_id - id of the store
    *   store_password - unique generated password for the store
    * Optional:
    *   success_url - success callback url
    *   fail_url - failed callback url
    */
    public function __construct($aParams)
    {
        //Required parameters
        $aRequired = array('store_id', 'store_password');
        $aOptional = array('success_url','fail_url');
                        
        foreach($aRequired as $required)
            if(!array_key_exists($required, $aParams) || !$aParams[$required])
                throw new EgoPayException("This param is required - '$required'");
        
        $aBoth = array_merge($aRequired,$aOptional);
        foreach($aBoth as $key)
            if(array_key_exists($key, $aParams) && $aParams[$key]) {
                $name = preg_replace('/(?<=_)([a-z]{1})/ie', 'strtoupper(\'$1\')', $key);
                $name = str_replace('_', '', $name);
                $name = '_' . $name;
                $this->{$name} = $aParams[$key];
            }
    }      
    
    /**
     * Creates confirmation url 
     * @param type $aData - data that will be sent
     * @return string - confirmation url
     */
    public function getConfirmationUrl($aData)
    {
        $sHash = $this->createHash($aData);                
        return self::EGOPAY_PAYMENT_URL . '/?hash=' . urlencode($sHash);      
    }   
    
    public function sendRequest($aData)
    {
    	$sUrl = $this->getConfirmationUrl($aData);
    	header('Location: '.$sUrl);
    }
    
    /**
     * Creates encoded data hash
     * @param type $aData
     * @return type 
     */
    public function createHash($aData)
    {
        $aRequired = array('amount','currency');
        
        foreach($aRequired as $required)
            if(!array_key_exists($required, $aData) || !$aData[$required])
                throw new EgoPayException("This param is required - '$required'");
            
        if (!empty($this->_successUrl))
            $aData['success_url'] = $this->_successUrl;
        if (!empty($this->_failUrl))
            $aData['fail_url'] = $this->_failUrl;
        
        $sData = serialize($aData);        
        $sResult = $this->_storeId . $this->encode($sData);
        return $sResult;
    }      
    
    /**
     * Required for encoding
     * @param type $string
     * @return type 
     */
    protected function safe_b64encode($string) {
        $data = base64_encode($string);
        $data = str_replace(array('+','/','='),array('-','_',''),$data);
        return $data;
    }

    /**
     * Encodes given value
     * @param type $value
     * @return type 
     */
    protected function encode($data){ 
        if(!$data){return false;}
        $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
        $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
        $crypttext = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $this->_storePassword, $data, MCRYPT_MODE_ECB, $iv);
        return trim($this->safe_b64encode($crypttext)); 
    }
    
   
}

class EgoPaySciCallback 
{
    /**
     * Current SCI version
     */ 
    const VERSION = '1.1';
    
    /**
     * SCI payment URL
     */
    const EGOPAY_REQUEST_URL = "https://www.egopay.com/payments/request";
    
    /**
     * EgoPay Store ID
     */
    protected $_storeId;
    
    /**
     * EgoPay Store password
     */
    protected $_storePassword;
    
    /**
     * After specified amount of seconds, the request is treated as expired
     */
    protected $_timeOut = 15;
    
   /**
    * Constructor
    * @param mixed $aParams - parameters that initiate API object
    * The available parameters are:
    * Required:
    *   store_id - id of the store
    *   store_password - unique generated password for the store
    */
    public function __construct($aParams)
    {
        //Required parameters
        $aRequired = array('store_id','store_password');
        
        foreach($aRequired as $required)
            if(!array_key_exists($required, $aParams) || !$aParams[$required])
                throw new EgoPayException("This param is required - '$required'");
        
        foreach($aRequired as $key)
            if(array_key_exists($key, $aParams) && $aParams[$key]) {
                $name = preg_replace('/(?<=_)([a-z]{1})/ie', 'strtoupper(\'$1\')', $key);
                $name = str_replace('_', '', $name);
                $name = '_' . $name;
                $this->{$name} = $aParams[$key];
            }      
    }  
    
     /**
     * Sends response to the EgoPay server with data that was sent from EgoPay 
     * server
     * @param type $aParams
     * @return string response
     */    
    public function getResponse($aParams)
    {
        if (!function_exists('curl_init')) {
            die("Curl library not installed.");
            return false;
        }
        
        if(!isset($aParams['product_id']))
            throw new EgoPayException("This param is required - 'product_id'");
        
        $aPost = array('product_id' => $aParams['product_id'],
                       'store_id' => $this->_storeId,
                       'security_password' => $this->_storePassword,
                       'v' => self::VERSION);
 
    	$ch = curl_init();
    
    	curl_setopt($ch, CURLOPT_URL, self::EGOPAY_REQUEST_URL);
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_6; en-us) AppleWebKit/525.27.1 (KHTML, like Gecko) Version/3.2.1 Safari/525.27.1");
    	curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_POST, true);
    	curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($aPost));
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    	curl_setopt($ch, CURLOPT_TIMEOUT, $this->_timeOut);
    	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    
    	$response = curl_exec($ch);
        
        if (!curl_errno($ch)) { #No errors
            $response_info = curl_getinfo($ch);
            if ($response_info['http_code'] != 200) {
                throw new EgoPayException('Invalid request to EgoPay. Response code: '. $response_info['http_code']);
            }        
        } else {
            if($response == 'INVALID')
                throw new EgoPayException('Invalid request to EgoPay');
        }

    	curl_close($ch);

        $aResponse = array();
        parse_str($response, $aResponse);

        return $aResponse;
    }
}

/**
 * EgoPay Api Exception class
 */
class EgoPayException extends Exception {
    
}